/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: winfo.h 2 2008-05-09 18:12:27Z ertl-honda $
 */

/*
 *  Ԥإå
 *  task.h ΤΤߥ󥯥롼ɤ뤳 
 */
#ifndef TOPPERS_WINFO_H
#define TOPPERS_WINFO_H

/*
 *  Ʊ֥̿Ȥδ֥åζʬ롼
 *
 *  Ʊ֥̿Ȥν֥åȴ֥åƬʬ϶
 *  ̤ˤʤäƤ롥ʲϡζʬ򰷤ηӥ롼
 *  Ǥ롥
 *
 *  ʣԤ塼Ʊ֥̿Ȥξ硤ƬʳԤ
 *  塼ˤϡΥ롼ϻȤʤޤ֥
 *  °TA_TPRIӥåȤ򻲾ȤΤǡΥӥåȤ¾Ū˻Ȥä
 *  ⡤Υ롼ϻȤʤ
 */

/*
 *  Ʊ֥̿Ȥν֥åζʬ
 */
typedef struct wait_object_initialization_block {
	ATR			wobjatr;		/* ֥° */
#if TTYPE_KLOCK == P_KLOCK
	POBJLOCK	p_obj_lock;		/* ֥ȥåؤΥݥ */
#endif /* TTYPE_KLOCK == P_KLOCK */
} WOBJINIB;

/*
 *  Ʊ֥̿Ȥδ֥åζʬ
 */
typedef struct wait_object_control_block {
	QUEUE		wait_queue;		/* Ԥ塼 */
	const WOBJINIB *p_wobjinib;	/* ֥åؤΥݥ */
#if TTYPE_KLOCK == F_KLOCK
	OBJLOCK		obj_lock;		/* ֥ȥå */
#endif /* TTYPE_KLOCK == F_KLOCK */
} WOBJCB;

/*
 *  ٥ȥե饰Ԥ֥å
 *
 *  flgptnϡwaiptnwfmodeƱ˻ȤȤϤʤᡤΤ
 *  Х󤹤뤳ȤǽǤ롥
 */
typedef struct winfo_flg{
	FLGPTN		waiptn;			/* Ԥѥ */
	MODE		wfmode;			/* Ԥ⡼ */
	FLGPTN		flgptn;			/* ԤΥѥ */
}WINFO_FLG;

/*
 *  ǡ塼Ԥ֥å
 *
 *  ǡ塼ؤԤȥǡ塼μԤǡƱԤ
 *  ֥åȤ
 */
typedef struct winfo_dtq{
	intptr_t	data;			/* ǡ */
}WINFO_DTQ;

/*
 *  ͥ٥ǡ塼Ԥ֥å
 *
 *  ͥ٥ǡ塼ؤԤͥ٥ǡ塼μԤǡ
 *  ƱԤ֥åȤ
 */
typedef struct winfo_pdq{
	intptr_t	data;			/* ǡ */
	PRI			datapri;		/* ǡͥ */
}WINFO_PDQ;

/*
 *  ᡼ܥåԤ֥å
 */
typedef struct winfo_mbx{
	T_MSG		*pk_msg;		/* å */
}WINFO_MBX;

/*
 *  ĹסԤ֥å
 */
typedef struct winfo_mpf{
	void		*blk;			/* ֥å */
}WINFO_MPF;

/*
 *  TCBϿ륪֥Ԥ֥å
 */
typedef union winfo_obj{
	WINFO_FLG flg;
	WINFO_DTQ dtq;
	WINFO_PDQ pdq;
	WINFO_MBX mbx;
	WINFO_MPF mpf;
}WINFO_OBJ;

#endif  /* TOPPERS_WINFO_H */
