/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2006 by GJ Business Division RICOH COMPANY,LTD. JAPAN  
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_serial.h 91 2009-01-25 16:50:43Z ertl-honda $
 */

/*
 * ꥢI/OǥХSIO˥ɥ饤СAT91SKYEYEѡ
 */

#ifndef TOPPERS_TARGET_SERIAL_H
#define TOPPERS_TARGET_SERIAL_H

#include "at91skyeye.h"

/*
 *  SIOγߥϥɥΥ٥ֹ
 */
#define INHNO_SIO_PRC1   (0x10000|IRQ_USART0)  /* ߥϥɥֹ */
#define INTNO_SIO_PRC1   (0x10000|IRQ_USART0)  /* ֹ */
#define INTPRI_SIO_PRC1       -2               /* ͥ */
#define INTATR_SIO_PRC1       0U               /* ° */

#define INHNO_SIO_PRC2   (0x20000|IRQ_USART0)  /* ߥϥɥֹ */
#define INTNO_SIO_PRC2   (0x20000|IRQ_USART0)  /* ֹ */
#define INTPRI_SIO_PRC2       -2               /* ͥ */
#define INTATR_SIO_PRC2       0U               /* ° */

#define INHNO_SIO_PRC3   (0x40000|IRQ_USART0)  /* ߥϥɥֹ */
#define INTNO_SIO_PRC3   (0x40000|IRQ_USART0)  /* ֹ */
#define INTPRI_SIO_PRC3       -2               /* ͥ */
#define INTATR_SIO_PRC3       0U               /* ° */

#define INHNO_SIO_PRC4   (0x80000|IRQ_USART0)  /* ߥϥɥֹ */
#define INTNO_SIO_PRC4   (0x80000|IRQ_USART0)  /* ֹ */
#define INTPRI_SIO_PRC4       -2               /* ͥ */
#define INTATR_SIO_PRC4       0U               /* ° */

/*
 *  ꥢI/Oݡȿ
 */
#define TNUM_SIOP		2		/* ݡȤ륷ꥢI/OݡȤο */


#ifndef TOPPERS_MACRO_ONLY

/*
 *  ꥢI/Oݡȴ֥å
 */
typedef struct sio_port_control_block	SIOPCB;

/*
 *  Хå롼μֹ
 */
#define SIO_RDY_SND	1U		/* ǽХå */
#define SIO_RDY_RCV	2U		/* ΥХå */

/*
 * ͥ뵯ưΥѤνin usart.h
 */
extern  void at91skyeye_init_uart(uint_t siopid);

/*
 *  UARTΥݡ󥰽
 */
Inline void
at91skyeye_putc(char_t c)
{
	sil_wrw_mem((void *)USART0_THR, c);
}

/*
 *  SIOɥ饤Фν
 */
extern void sio_initialize(intptr_t exinf);

/*
 *  ꥢI/OݡȤΥץ
 */
extern SIOPCB *sio_opn_por(ID siopid, intptr_t exinf);

/*
 *  ꥢI/OݡȤΥ
 */
extern void sio_cls_por(SIOPCB *p_siopcb);

/*
 *  SIOγߥϥɥ
 */
extern void sio_handler(void);

/*
 *  ꥢI/OݡȤؤʸ
 */
extern bool_t sio_snd_chr(SIOPCB *siopcb, char_t c);

/*
 *  ꥢI/OݡȤʸ
 */
extern int_t sio_rcv_chr(SIOPCB *siopcb);

/*
 *  ꥢI/OݡȤΥХåε
 */
extern void sio_ena_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤΥХåζػ
 */
extern void sio_dis_cbr(SIOPCB *siopcb, uint_t cbrtn);

/*
 *  ꥢI/OݡȤǽХå
 */
extern void sio_irdy_snd(intptr_t exinf);

/*
 *  ꥢI/OݡȤμΥХå
 */
extern void sio_irdy_rcv(intptr_t exinf);

#endif /* TOPPERS_MACRO_ONLY */
#endif /* TOPPERS_TARGET_SERIAL_H */
