/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel
 * 
 *  Copyright (C) 2000-2003 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2006-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: target_support.S 191 2009-04-16 23:25:34Z ertl-honda $
 */

/*
 *  åװ¸⥸塼 ֥AT91SKYEYEѡ
 */

#define  TOPPERS_MACRO_ONLY
#define UINT_C(val)		(val)		/* uint_tޥ */
#define ULONG_C(val)	(val)		/* ulong_tޥ */
#include "kernel_impl.h"
#include "target_asm.inc"
#include "offset.h"

/*
 *  ٥Υåȥƥ¸ν
 *
 *  ȥåץ⥸塼ǡ˸ƤӽФ롥
 */
        .text
        .align 2
        .global hardware_init_hook
hardware_init_hook:
        mov     pc, lr


        .text
        .align 2
        .global software_init_hook
software_init_hook:
        mov     pc, lr

        .text
        .align 2
        .global software_term_hook
software_term_hook:
        mov     pc, lr


/*
 * ߥϥɥ
 *
 * IRQ 㳰٥ƤӽФ
 */
    .text
    .align 2
    .global irq_handler
irq_handler:
    /* 
     * IRQ⡼ɤǼ¹Ԥ
     */
    /* 
     *  Υ⡼(ѡХ⡼)
     *  ܹԤƥȤ¸
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    stmfd sp!, {r0-r3, ip, lr, pc} /* pcϥߡ */

    /*
     * spsrϤ뤿IRQ⡼ɤ
     */
    msr   cpsr, #(CPSR_IRQ|CPSR_IRQ_BIT)
    sub   r0, lr, #4
    mrs   r1, spsr

    /*
     *  ߥϥɥ¹ԻΥ⡼ɡʥѡХ⡼ɡˤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */
    mov   lr, sp          /* λΥåΤ */

    /*
     *  ¿ųߤȽ
     */
    my_accb r2, r3              /* 㳰ߥͥȲ */
    ldr   r3, [r2, #ACCB_excpt_nest_count]
    add   r0, r3, #1            /* 㳰ߥͥȲ򹹿 */
    str   r0, [r2, #ACCB_excpt_nest_count]
    cmp   r3, #0    
    bne   irq_handler_1

    /* 
     * ܤ㳰ʳߡˤʤ饹åѹ
     */
    my_istkpt sp, r0

irq_handler_1:
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    ldr   r1, =AIC_IVR
    ldr   r3, [r1]

    /*
     *  װȽ
     */
    ldr   r1, =AIC_ISR
    ldr   r3, [r1]

    /*
     *  װγͥ٤(ǥ)ͥ٥ޥ򥻥å
     *  롥ޤκݡϥɥ¹(ǥ)ͥ٥ޥ
     *  ¸롥
     */
    my_tacb r2, r0              /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r0, [r2, #TACB_ipm]
    stmfd sp!,{r0}         
    my_inh_ipm_table r0, r1     /* ͥ٤ */
    ldr   r1, [r0, r3, lsl #2]  /* r1<-ͥ   */
    str   r1, [r2, #TACB_ipm]   /* (ǥ)ͥ٥ޥ򥻥å */

    /*
     * ϡɥ(IRC)ϳߤդ塤ߤ˱ͥ٥ޥ
     * 򥻥åȤ롥Τ᥽եȥŪˤä˽ϹԤɬפϤʤ
     * եȥŪ(ǥ)ͥ٥ޥ夲ݤˤϡ
     * ͥ٥ޥ˱Ƴ׵ػߥե饰ˤߤػߤ롥
     */
    /*
     *  ߥϥɥεưϤ
     */
    my_inh_table r0, r1        /* ߥϥɥơ֥ɤ߽Ф  */
    ldr   r0, [r0, r3, lsl #2] /* r0<-ߥϥɥ            */

    /*
     *  EOIΤ¸
     */
    mov   r1, #1
    mov   r1, r1, lsl r3
    stmfd sp!, {r1} 

    stmfd sp!,{r3}       /* inhno ¸  */

    /* 
     * ߵ
     */
    msr   cpsr, #(CPSR_SVC)

#ifdef LOG_INH_ENTER
    stmfd sp!,{r0}
    mov   r0, r3         /* inhno ѥ᡼    */
    bl    log_inh_enter  /* log_inh_enterƤӽФ */
    ldmfd sp!,{r0}
#endif /* LOG_INH_ENTER */

    /* 
     * ߥϥɥθƤӽФ
     */
    mov   lr, pc
    mov   pc, r0

    ldmfd sp!,{r0}       /* inhno   */
#ifdef LOG_INH_LEAVE
    bl    log_inh_leave  /* log_inh_leaveƤӽФ */
#endif /* LOG_INH_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)
    
    /*
     * ߥꥢ
     */
    ldmfd   sp!,{r0}
    ldr     r3, =AIC_EOI
    str     r0, [r3]

    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    my_tacb r0, r2              /* ͥ٥ޥ     */
    str     r1, [r0, #TACB_ipm]
    my_ipm_mask_table r0, r2    /* (ǥ)γͥ٤Τ¸뤿 */
    rsb     r1, r1,  #0         /* ǥåȤ뤿ȿž */
    ldr     r2, [r0, r1, lsl #2]/* ׵ػߥե饰 */
    my_tacb r0, r1              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr     r1, [r0, #TACB_idf]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */

    mvn   lr, #0
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */
    b     ret_int


/*
 * åȰ¸㳰
 */
    .text
    .global target_exc_handler
target_exc_handler:
    /*
     *  㳰¹ԤΥ⡼ɡʥѡХ⡼ɡˤ
     *  ߥå֡CPUå֤CPU㳰ȯ
     *  ֤Ѿ롥
     */
    msr   cpsr, #(CPSR_SVC|CPSR_FIQ_BIT|CPSR_IRQ_BIT) 
    str   r0, [sp, #0x18] /* Ϥ򥹥å */
    stmfd sp!, {r1}       /* spsr򥹥å¸ */    
    mov   lr, sp          /* λΥåΤ */
    my_tacb r0, r1        /* ȯγͥ٥ޥ򥹥å¸ */
    ldr   r1, [r0, #TACB_ipm]
    stmfd sp!, {r1}

    /* 
     * ƥȽΤᡤexcpt_nest_count 򥹥å¸
     * å¸ߤexcpt_nest_count-1ȼǤ뤬
     * åѤǤǥХåԤ䤹Τǡå
     * ¸롥
     */
    my_accb r0, r1
    ldr   r1, [r0, #ACCB_excpt_nest_count]
    stmfd sp!, {r1}

    mov   r3,  sp         /* 㳰ե졼Ϥ¸ */

    /*
     *  ¿ųߤȽ
     */
    add   r1, r1, #1
    str   r1, [r0]
    cmp   r1, #1
    bne   target_exc_handler_1

    /* 
     * ܤμ¹Ԥʤ饹åѹ
     */
    my_istkpt sp, r0

target_exc_handler_1:    
    stmfd sp!, {lr}     /* ѤΥåݥ󥿤¸ */

    /*
     *  locspnid¸
     */
    my_pcb r0, r1
    ldr    r1, [r0,#PCB_locspnid]
    stmfd  sp!,{r1}

    /* 
     * ȯγͥ٥ޥ򥹥å¸
     * ߥϥɥȽи롼ͭ뤿¸
     */
    my_tacb r0, r1
    ldr   r1, [r0, #TACB_ipm]
    stmfd sp!, {r1}

    /*
     *  CPU㳰ϥɥεưϤ
     */
    my_exch_table r0, r1       /* ߥϥɥơ֥ɤ߽Ф */
    ldr   r1, [r0, r2, lsl #2] /* r1<-㳰ϥɥ                 */

    stmfd sp!,{r2}      /* excno ¸ */

    /* 
     * ߵ 
     * CPUå֡ߥå֤ϷѾ
     */
    ldr   r0, [lr]
    and   r0, r0, #(CPSR_IRQ_BIT|CPSR_FIQ_BIT)
    orr   r0, r0, #(CPSR_SVC)
    msr   cpsr, r0

#ifdef LOG_EXC_ENTER
    stmfd sp!,{r1,r3}
    mov   r0, r2         /* excno ѥ᡼    */
    bl    log_exc_enter  /* log_exc_enterƤӽФ */
    ldmfd sp!,{r1,r3}
#endif /* LOG_EXC_ENTER */

    /* 
     * CPU㳰ϥɥθƤӽФ
     *
     * 㳰ե졼ƬȤϤ
     */
    mov   r0, r3
    mov   lr, pc
    mov   pc, r1

target_ret_exc:
    ldmfd sp!,{r0}       /* excno   */
#ifdef LOG_EXC_LEAVE
    bl    log_exc_leave  /* log_exc_leaveƤӽФ */
#endif /* LOG_EXC_LEAVE */

    /*
     * ͥγߤػߤ
     */
    msr   cpsr, #(CPSR_SVC|CPSR_IRQ_BIT)

    .global target_ret_int
target_ret_int:
    /*
     * ͥ٥ޥ򸵤᤹
     */
    ldmfd sp!, {r1}             /* γͥ٥ޥ */
    my_tacb r0, r2              /* ͥ٥ޥ     */
    str     r1, [r0, #TACB_ipm]
    my_ipm_mask_table r0, r2    /* (ǥ)γͥ٤Τ¸뤿 */
    rsb     r1, r1,  #0         /* ǥåȤ뤿ȿž */
    ldr     r2, [r0, r1, lsl #2]/* ׵ػߥե饰 */
    my_tacb r0, r1              /* Ƴߤγ׵ػߥե饰ξ֤ */
    ldr     r1, [r0, #TACB_idf]
    /*
     * Ƴߤγ׵ػߥե饰ξ֤(ǥ)γͥ٤Τ¸
     * γ׵ػߥե饰ξ֤ORȤꡤ뤳Ȥˤꡤ
     * IRCγߵĥ쥸ؤͤꤹ롥
     */

    mvn   lr, #0
    ldr   r0, =AIC_IDCR
    str   lr, [r0]
    orr   r1, r1, r2            /* ޥꤵƤʤߤε */
    mvn   r1, r1                /* ͤ */
    ldr   r0, =AIC_IECR
    str   r1, [r0]

    /*
     * CPU㳰ȯlocspnidr0
     */
    ldmfd sp!,{r0} 

    /*
     * åݥ󥿤
     */
    ldmfd sp!, {r2}             /* Υåݥ󥿤 */
    mov   sp, r2
    
    /*
     * νARM¸Ǽ¹
     */
    b     ret_exc
