/*
 *  TOPPERS/FMP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Flexible MultiProcessor Kernel  
 * 
 *  Copyright (C) 2007 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: chip_test.h 228 2009-04-26 14:10:19Z ertl-honda $
 */

/*
 *		ƥȥץΥåװ¸MPCoreѡ
 */

#ifndef TOPPERS_CHIP_TEST_H
#define TOPPERS_CHIP_TEST_H

/*
 *  åפǶ̤
 */
#define CPUEXC1		(4|0x10000)		/* ɥ顼㳰 */
#define CPUEXC2		(4|0x20000)		/* ɥ顼㳰 */
#define CPUEXC3		(4|0x30000)		/* ɥ顼㳰 */
#define CPUEXC4		(4|0x40000)		/* ɥ顼㳰 */
#define RAISE_CPU_EXCEPTION	(*((volatile int *) 0xFFFFFEC1U))
#define CANNOT_RETURN_CPUEXC

#ifdef SOC_DESIGNER
#define TASK_LOOP	ULONG_C(1000000)
#endif /* SOC_DESIGNER */

/*
 *  ǽɾץΤ
 */

/*
 *  ޤγֹ
 */
#define _INTNO_TIMER  29

/*
 *  ǽɾν
 */
#ifndef CPU1_PERF_PRE_HOOK
#define CPU1_PERF_PRE_HOOK    dis_int(_INTNO_TIMER);
#endif  /* CPU1_PERF_PRE_HOOK */

#ifndef CPU1_PERF_POST_HOOK
#define CPU1_PERF_POST_HOOK   ena_int(_INTNO_TIMER);
#endif  /* CPU1_PERF_POST_HOOK */

#ifdef TOPPERS_SYSTIM_LOCAL

#ifndef CPU2_PERF_PRE_HOOK
#define CPU2_PERF_PRE_HOOK    dis_int(_INTNO_TIMER);
#endif  /* CPU2_PERF_PRE_HOOK */
#ifndef CPU2_PERF_POST_HOOK
#define CPU2_PERF_POST_HOOK   ena_int(_INTNO_TIMER);
#endif  /* CPU2_PERF_POST_HOOK */

#endif /* TOPPERS_SYSTIM_LOCAL */

#endif /* TOPPERS_CHIP_TEST_H */
