/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007-2009 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: test_mact_tsk3.c 175 2009-03-03 13:19:45Z ertl-kikuchi $
 */

/* 
 *		mact_tskӥΥƥ(3)
 *  ڥƥȤŪ
 *    оݥԤΥФơmact_tskȯԤ롥
 *
 *  ڥƥȹܡ
 *
 *    (2-H) ץå˳դ줿¾ץå
 *    (2-I) ¾ץå˳դ줿򼫥ץå
 */

#include <kernel.h>
#include <t_syslog.h>
#include <sil.h>
#include "kernel_cfg.h"
#include "test_lib.h"

void
task1_4(intptr_t exinf)
{
	ER		ercd;
	FLGPTN flgptn;
  
	check_point(1);
	ercd = mact_tsk(TASK1_5,2);
	check_ercd(ercd, E_OK);

	check_point(2);
	ercd = mact_tsk(TASK1_5,2);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ 1ܵưԤ
	do{
		ercd = pol_flg(FLG1,1,TWF_ANDW,&flgptn);
	}while(ercd != E_OK);

	check_point(3);
	ercd = wup_tsk(TASK1_5);
	check_ercd(ercd, E_OK);

	//Ʊե饰Ԥ 2ܵưԤ
	do{
		ercd = pol_flg(FLG1,2,TWF_ANDW,&flgptn);
		}while(ercd != E_OK);

	check_point(4);
	ercd = wup_tsk(TASK1_5);
	check_ercd(ercd, E_OK);

//¾ץå˳դ줿򼫥ץå
	check_point(5);
	ercd = mact_tsk(TASK2_1,1);
	check_ercd(ercd, E_OK);

	check_point(7);
	ercd = mact_tsk(TASK2_1,1);
	check_ercd(ercd, E_OK);

	check_point(8);
	ercd = wup_tsk(TASK2_1);
	check_ercd(ercd, E_OK);

	check_point(11);
	ercd = wup_tsk(TASK2_1);
	check_ercd(ercd, E_OK);

  /*
    * ƥȽλ
    */
  
	check_finish(13);//CPU1
}

void
task1_5(intptr_t exinf)
{
	ER		ercd;
	static uint_t actno=0;

	actno++;
	if(actno==1){
		check_point(1);
		ercd = set_flg(FLG1,1);
		check_ercd(ercd, E_OK);    
	}else if(actno ==2){
		check_point(3);
		ercd = set_flg(FLG1,2);
		check_ercd(ercd, E_OK);    
	}

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	if(actno==1){
		check_point(2);
	}else if(actno ==2){
		check_point(4);
	/*
	 * ƥȽλ
	*/
		check_finish(5);
	}
  
}

void
task2_1(intptr_t exinf)
{
	ER		ercd;
	static uint_t actno=0;

	actno++;
	if(actno==1){
		check_point(6);
	}else if(actno ==2){
		check_point(10);
	}

	ercd = slp_tsk();
	check_ercd(ercd, E_OK);

	if(actno==1){
		check_point(9);
	}else if(actno ==2){
		check_point(12);
		ercd = slp_tsk();
		check_ercd(ercd, E_OK);
	}
  
}
